%{


/************************************************************************/
/* Code section */
/* */
/* This part will be included as is into the parser code. */
/* */
/************************************************************************/


#include <stdio.h>

char *chomp (char* line)
{
  if (line[strlen(line)-1] == '\n') { line[strlen(line)-1] = 0; }
  return line;
}


%}


/************************************************************************/
/* Definition section */
/* */
/* Remark: the rule '^[ \t]+\n' is not the same as '^[ \t]+$'. In the */
/* first case the string 'yytext' will contain the character */
/* '\n'. On the other hand, the string 'yytext' that matches */
/* second rule won't include the trailing character '\n'. */
/* */
/* Remark: The rule 'DST_CONFIG' will be matched only if the statement */
/* tag 'dst_rules' is activated. All the other rules will be */
/* evalutated whether 'dst_rules' is activated or not. */
/************************************************************************/


FIELD_SEPARATOR \t
BLANK_LINE ^[ \t]+\n
EMPTY_LINE ^\n

IP_JOKER @
IP_NUMBER [0-9]+|{IP_JOKER}
IP_ADRESS {IP_NUMBER}\.{IP_NUMBER}\.{IP_NUMBER}\.{IP_NUMBER}
PORT [0-9]+
SRC_CONFIG ^{IP_ADRESS}{FIELD_SEPARATOR}+{PORT}\n
DST_CONFIG ^{FIELD_SEPARATOR}+{IP_ADRESS}{FIELD_SEPARATOR}+{PORT}\n


%s dst_rules

/************************************************************************/
/* Rules section */
/************************************************************************/


%%
BEGIN(src_rules);

{SRC_CONFIG} {
                 fprintf (stdout, "SRC: [%s]\n", chomp(yytext));
                 BEGIN(dst_rules);
              }

<dst_rules>{DST_CONFIG} { fprintf (stdout, "DST: [%s]\n", chomp(yytext)); }

{BLANK_LINE} { fprintf (stdout, "Blank line\n"); }
{EMPTY_LINE} { fprintf (stdout, "Empty line\n"); }

.* { return 1; }

%%

/* No extra C code */

